/***************************************************************
 ************************* A TPP Project ***********************
 ******************** Visit http://tpp.dhs.org *****************
 ***************************************************************
main.h

Author(s): Paul Fleischer (polle@denmark.crosswinds.net)
Created: 20. June 1999

Copyright(c) 1999 The AKOS team.
All Rights Reserved.
****************************************************************/

#ifndef AKOS_hll_main_h
#define AKOS_hll_main_h

//************************ 1. INCLUDES ************************
#include "config.h" //I know that I should use <> instead of "" ;)
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>

#include "dstring.h" //The d(ynamic) string class
#include "aobject.h" //The AKOS object class

//******************* 2. BLOCK DEFINITIONS ********************
// CODE_BLOCK structure (could also be called executing block)
typedef struct {
  dstring *name;            //Name if the codeblock
  char *data;              //A pointer to the code, to be interpreted
  unsigned int dataSize;   //size of the code area(data);
  aobject *topobject;
  aobject *returnValue;
} CODE_BLOCK;

//********************** 3. FUNCTION PROTOTYPES *******************

/*******************
translate.cpp
Used to do inline calculations, and simple boolean expressions
 *******************/
//This is the one that should be called, it takes care of everything for you
bool translate(char *string, CODE_BLOCK *code);

//Used by translate() to do the actual calculations. (Should not be called)
bool transmul(char *string, unsigned int i, char mode, CODE_BLOCK *code);

/******************
main.cpp
Besides the main() function, this file contains all not-yet-classefied 
functions (This includes functions that are not finished.
**This file will be removed in the final version of AHLL** 
********************/

//A dummy function that will be replace by the monitor system.
//It just writes a error message to stdout
void emitError(char *module, int line, char *message);

//This is the function that analyses the string, and makes sure that the string
//(or parts of it) are passed to the right functions (translate, removeSpaces, getCommand etc.)
//It does the whole interpreting!
void analyseString(CODE_BLOCK *code);

#endif





